{
    "$graph": [
        {
            "inputs": [
                {
                    "type": {
                        "items": [
                            "null",
                            "File"
                        ],
                        "type": "array"
                    },
                    "id": "#expressiontool_test.cwl/file_array"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "expression": "${\n  var trueFile = [];\n  for (var i = 0; i < inputs.file_array.length; i++){\n    if (inputs.file_array[i] != null){\n      trueFile.push(inputs.file_array[i])\n    }\n  };\n  return {'output': trueFile};\n}\n",
            "id": "#expressiontool_test.cwl",
            "outputs": [
                {
                    "type": {
                        "items": "File",
                        "type": "array"
                    },
                    "id": "#expressiontool_test.cwl/output"
                }
            ]
        },
        {
            "inputs": [
                {
                    "inputBinding": {
                        "position": 1,
                        "valueFrom": "$(self.basename)"
                    },
                    "type": "File",
                    "id": "#initdir_test.cwl/input_bam"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "dockerPull": "quay.io/cdis/samtools:dev_cloud_support",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.input_bam)",
                            "entryname": "$(inputs.input_bam.basename)"
                        }
                    ]
                },
                {
                    "coresMin": 1,
                    "ramMin": "100MB",
                    "class": "ResourceRequirement",
                    "coresMax": 1
                }
            ],
            "outputs": [
                {
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.basename)"
                    },
                    "type": "File",
                    "id": "#initdir_test.cwl/bam_with_index"
                }
            ],
            "baseCommand": [
                "samtools",
                "index"
            ],
            "class": "CommandLineTool",
            "id": "#initdir_test.cwl"
        },
        {
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/input_bam"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/test_expr/output",
                    "type": {
                        "items": "File",
                        "type": "array"
                    },
                    "id": "#main/output_files"
                }
            ],
            "class": "Workflow",
            "steps": [
                {
                    "out": [
                        "#main/test_expr/output"
                    ],
                    "run": "#expressiontool_test.cwl",
                    "id": "#main/test_expr",
                    "in": [
                        {
                            "source": "#main/test_initworkdir/bam_with_index",
                            "valueFrom": "$([self, self.secondaryFiles[0]])",
                            "id": "#main/test_expr/file_array"
                        }
                    ]
                },
                {
                    "out": [
                        "#main/test_initworkdir/bam_with_index"
                    ],
                    "run": "#initdir_test.cwl",
                    "id": "#main/test_initworkdir",
                    "in": [
                        {
                            "source": "#main/input_bam",
                            "id": "#main/test_initworkdir/input_bam"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
